%{!?dnf_lowest_compatible: %global dnf_lowest_compatible 4.2.1}
%global dnf_plugins_extra_obsolete 2.0.0

# (ngompa): To avoid annoying problems...
%global __python %{__python3}

# OpenMandriva does not have a useful version of pykickstart
%bcond_with pykickstart

# OpenMandriva does not have rpmconf
%bcond_with rpmconf

# OpenMandriva does not have snapper
%bcond_with snapper

# OpenMandriva does not have tracer
%bcond_with tracer


Name:		dnf-plugins-extras
Version:	4.0.8
Release:	2
Summary:	Extras Plugins for DNF
Group:		System/Configuration/Packaging
License:	GPLv2+
URL:		https://github.com/rpm-software-management/%{name}
Source0:	https://github.com/rpm-software-management/dnf-plugins-extras/archive/%{name}-%{version}.tar.gz

BuildArch:	noarch
BuildRequires:	cmake
BuildRequires:	gettext
BuildRequires:	pkgconfig(python3)
BuildRequires:	python3-setuptools
BuildRequires:	python3-dnf >= %{dnf_lowest_compatible}
BuildRequires:	python3-nose
BuildRequires:	python3-sphinx

%description
Extras Plugins for DNF.

%package -n python3-%{name}-common
Summary:	Common files for Extras Plugins for DNF
Group:		System/Configuration/Packaging
Requires:	python3-dnf >= %{dnf_lowest_compatible}
Provides:	%{name}-common = %{version}-%{release}
Obsoletes:	%{name}-common < %{version}-%{release}
Obsoletes:	python3-%{name}-common < %{version}-%{release}
Obsoletes:	%{name} < %{version}-%{release}
Obsoletes:	%{name}-common-data < %{version}-%{release}
Conflicts:	python2-%{name}-common < %{version}-%{release}

%description -n python3-%{name}-common
Common files for Extras Plugins for DNF, Python 3 version.

%if %{with pykickstart}
%package -n python3-dnf-plugin-kickstart
Summary:	Kickstart Plugin for DNF
Group:		System/Configuration/Packaging
Requires:	python3-%{name}-common = %{version}-%{release}
BuildRequires:	python3-kickstart
Requires:	python3-kickstart
Provides:	dnf-command(kickstart)
Provides:	%{name}-kickstart = %{version}-%{release}
Provides:	dnf-plugin-kickstart = %{version}-%{release}
Provides:	python3-%{name}-kickstart = %{version}-%{release}
Conflicts:	python2-dnf-plugin-kickstart < %{version}-%{release}
Obsoletes:	python3-%{name}-kickstart < %{dnf_plugins_extra_obsolete}

%description -n python3-dnf-plugin-kickstart
Kickstart Plugin for DNF, Python 3 version. Install packages listed in a
Kickstart file.
%endif

%if %{with rpmconf}
%package -n python3-dnf-plugin-rpmconf
Summary:	RpmConf Plugin for DNF
Group:		System/Configuration/Packaging
BuildRequires:	python3-rpmconf
Requires:	python3-%{name}-common = %{version}-%{release}
Requires:	python3-rpmconf
Provides:	%{name}-rpmconf = %{version}-%{release}
Provides:	dnf-plugin-rpmconf = %{version}-%{release}
Provides:	python3-%{name}-rpmconf = %{version}-%{release}
Obsoletes:	python3-%{name}-rpmconf < %{dnf_plugins_extra_obsolete}

%description -n python3-dnf-plugin-rpmconf
RpmConf Plugin for DNF, Python 3 version. Handles .rpmnew, .rpmsave every
transaction.
%endif

%if %{with snapper}
%package -n python3-dnf-plugin-snapper
Summary:	Snapper Plugin for DNF
Group:		System/Configuration/Packaging
Requires:	python3-%{name}-common = %{version}-%{release}
Requires:	python3-dbus
Requires:	snapper
Provides:	%{name}-snapper = %{version}-%{release}
Provides:	dnf-plugin-snapper = %{version}-%{release}
Provides:	python3-%{name}-snapper = %{version}-%{release}
Conflicts:	python2-dnf-plugin-snapper < %{version}-%{release}
Obsoletes:	python3-%{name}-snapper < %{dnf_plugins_extra_obsolete}

%description -n python3-dnf-plugin-snapper
Snapper Plugin for DNF, Python 3 version. Creates snapshot every transaction.
%endif

%package -n python3-dnf-plugin-system-upgrade
Summary:	System Upgrade Plugin for DNF
Group:		System/Configuration/Packaging
Requires:	python3-%{name}-common = %{version}-%{release}
Requires:	python3-systemd
Provides:	dnf-command(system-upgrade)
Provides:	%{name}-system-upgrade = %{version}-%{release}
Provides:	system-upgrade = %{version}-%{release}
Provides:	dnf-plugin-system-upgrade = %{version}-%{release}
Provides:	python3-%{name}-system-upgrade = %{version}-%{release}
Obsoletes:	python3-%{name}-system-upgrade < %{dnf_plugins_extra_obsolete}
Obsoletes:	fedup < 0.9.4
Obsoletes:	dnf-plugin-system-upgrade < 0.10
Conflicts:	python2-dnf-plugin-system-upgrade < %{version}-%{release}
BuildRequires:	systemd-units
BuildRequires:	pkgconfig(libsystemd)
BuildRequires:	python3-systemd
%{?systemd_requires}

%description -n python3-dnf-plugin-system-upgrade
System Upgrade Plugin for DNF, Python 3 version. Enables offline system upgrades
using the "dnf system-upgrade" command.

%if %{with tracer}
%package -n python3-dnf-plugin-tracer
Summary:	Tracer Plugin for DNF
Group:		System/Configuration/Packaging
Requires:	python3-%{name}-common = %{version}-%{release}
Requires:	python3-tracer >= 0.6.12
Provides:	dnf-plugin-tracer = %{version}-%{release}
Provides:	%{name}-tracer = %{version}-%{release}
Provides:	python3-%{name}-tracer = %{version}-%{release}
Conflicts:	python2-dnf-plugin-tracer < %{version}-%{release}
Obsoletes:	python3-%{name}-tracer < %{dnf_plugins_extra_obsolete}

%description -n python3-dnf-plugin-tracer
Tracer Plugin for DNF, Python 3 version. Finds outdated running applications in
your system every transaction.
%endif

%package -n python3-dnf-plugin-torproxy
Summary:	Tor Proxy Plugin for DNF
Group:		System/Configuration/Packaging
Requires:	python3-%{name}-common = %{version}-%{release}
Requires:	python3-pycurl
Provides:	dnf-plugin-torproxy = %{version}-%{release}
Provides:	%{name}-torproxy = %{version}-%{release}
Provides:	python3-%{name}-torproxy = %{version}-%{release}
Obsoletes:	python3-%{name}-torproxy < %{dnf_plugins_extra_obsolete}

%description -n python3-dnf-plugin-torproxy
Tor proxy plugin forces DNF to use Tor to download packages. It makes sure that
Tor is working and avoids leaking the hostname by using the proper SOCKS5 interface.

%package -n python3-dnf-plugin-showvars
Summary:	Showvars Plugin for DNF
Group:		System/Configuration/Packaging
Requires:	python3-%{name}-common = %{version}-%{release}
Provides:	dnf-plugin-showvars = %{version}-%{release}
Provides:	%{name}-showvars = %{version}-%{release}
Provides:	python3-%{name}-showvars = %{version}-%{release}

%description -n python3-dnf-plugin-showvars
This plugin dumps the current value of any defined DNF variables.  For example
$releasever and $basearch.

%prep
%autosetup -n %{name}-%{version}%{?prerel:-%{prerel}} -p1

%build
%cmake -DPYTHON_DESIRED:str=3
%make_build
make doc-man

%install
%make_install -C build

mkdir -p %{buildroot}%{_unitdir}/system-update.target.wants/
cd %{buildroot}%{_unitdir}/system-update.target.wants/
  ln -sr ../dnf-system-upgrade.service
cd -

%find_lang %{name}

%if ! %{with pykickstart}
rm -rf %{buildroot}%{python3_sitelib}/dnf-plugins/kickstart.*
rm -rf %{buildroot}%{python3_sitelib}/dnf-plugins/__pycache__/kickstart.*
rm -rf %{buildroot}%{_mandir}/man8/dnf.plugin.kickstart.*
%endif

%if ! %{with rpmconf}
rm -rf %{buildroot}%{python3_sitelib}/dnf-plugins/rpmconf.*
rm -rf %{buildroot}%{python3_sitelib}/dnf-plugins/rpm_conf.*
rm -rf %{buildroot}%{python3_sitelib}/dnf-plugins/__pycache__/rpmconf.*
rm -rf %{buildroot}%{python3_sitelib}/dnf-plugins/__pycache__/rpm_conf.*
rm -rf %{buildroot}%{_mandir}/man8/dnf.plugin.rpmconf.*
rm -rf %{buildroot}%{_sysconfdir}/dnf/plugins/rpmconf.conf
rm -rf %{buildroot}%{_mandir}/man8/dnf.plugin.rpmconf.*
%endif

%if ! %{with snapper}
rm -rf %{buildroot}%{python3_sitelib}/dnf-plugins/snapper.*
rm -rf %{buildroot}%{python3_sitelib}/dnf-plugins/__pycache__/snapper.*
rm -rf %{buildroot}%{_mandir}/man8/dnf.plugin.snapper.*
%endif

%if ! %{with tracer}
rm -rf %{buildroot}%{python3_sitelib}/dnf-plugins/tracer.*
rm -rf %{buildroot}%{python3_sitelib}/dnf-plugins/__pycache__/tracer.*
rm -rf %{buildroot}%{_mandir}/man8/dnf.plugin.tracer.*
%endif


%check
%if ! %{with pykickstart}
rm -rf tests/test_kickstart.*
%endif

%if ! %{with rpmconf}
rm -rf tests/test_rpmconf.*
%endif

PYTHONPATH="%{buildroot}%{python3_sitelib}:%{buildroot}%{python3_sitelib}/dnf-plugins/" nosetests-%{python3_version} -s tests/

%files -n python3-%{name}-common -f %{name}.lang
%{python3_sitelib}/dnfpluginsextras/
%license COPYING
%doc AUTHORS README.rst

%if %{with pykickstart}
%files -n python3-dnf-plugin-kickstart
%{python3_sitelib}/dnf-plugins/kickstart.*
%{python3_sitelib}/dnf-plugins/__pycache__/kickstart.*
%{_mandir}/man8/dnf.plugin.kickstart.*
%endif

%if %{with rpmconf}
%files -n python3-dnf-plugin-rpmconf
%config(noreplace) %{_sysconfdir}/dnf/plugins/rpmconf.conf
%{python3_sitelib}/dnf-plugins/rpm_conf.*
%{python3_sitelib}/dnf-plugins/__pycache__/rpm_conf.*
%{_mandir}/man8/dnf.plugin.rpmconf.*
%endif

%if %{with snapper}
%files -n python3-dnf-plugin-snapper
%{python3_sitelib}/dnf-plugins/snapper.*
%{python3_sitelib}/dnf-plugins/__pycache__/snapper.*
%{_mandir}/man8/dnf.plugin.snapper.*
%endif

%files -n python3-dnf-plugin-system-upgrade
%{_unitdir}/dnf-system-upgrade.service
%{_unitdir}/system-update.target.wants/dnf-system-upgrade.service
%{_unitdir}/dnf-system-upgrade-cleanup.service
%{python3_sitelib}/dnf-plugins/system_upgrade.py
%{python3_sitelib}/dnf-plugins/__pycache__/system_upgrade*.pyc
%{_mandir}/man8/dnf.plugin.system-upgrade.*

%if %{with tracer}
%files -n python3-dnf-plugin-tracer
%{python3_sitelib}/dnf-plugins/tracer.*
%{python3_sitelib}/dnf-plugins/__pycache__/tracer.*
%{_mandir}/man8/dnf.plugin.tracer.*
%endif

%files -n python3-dnf-plugin-torproxy
%config(noreplace) %{_sysconfdir}/dnf/plugins/torproxy.conf
%{python3_sitelib}/dnf-plugins/torproxy.*
%{python3_sitelib}/dnf-plugins/__pycache__/torproxy*.pyc
%{_mandir}/man8/dnf.plugin.torproxy.*

%files -n python3-dnf-plugin-showvars
%{python3_sitelib}/dnf-plugins/showvars.*
%{python3_sitelib}/dnf-plugins/__pycache__/showvars.*
%{_mandir}/man8/dnf.plugin.showvars.*
